Index: /trunk/include/VBox/tm.h
===================================================================
--- /trunk/include/VBox/tm.h	(revision 19506)
+++ /trunk/include/VBox/tm.h	(revision 19507)
@@ -181,5 +181,4 @@
 VMMDECL(PTMTIMERR0) TMTimerR0Ptr(PTMTIMER pTimer);
 VMMDECL(PTMTIMERRC) TMTimerRCPtr(PTMTIMER pTimer);
-VMMDECL(int)      TMTimerDestroy(PTMTIMER pTimer);
 VMMDECL(int)      TMTimerSet(PTMTIMER pTimer, uint64_t u64Expire);
 VMMDECL(int)      TMTimerSetMillies(PTMTIMER pTimer, uint32_t cMilliesToNext);
@@ -223,4 +222,5 @@
 VMMR3DECL(int)    TMR3TimerCreateInternal(PVM pVM, TMCLOCK enmClock, PFNTMTIMERINT pfnCallback, void *pvUser, const char *pszDesc, PPTMTIMERR3 ppTimer);
 VMMR3DECL(PTMTIMERR3) TMR3TimerCreateExternal(PVM pVM, TMCLOCK enmClock, PFNTMTIMEREXT pfnCallback, void *pvUser, const char *pszDesc);
+VMMR3DECL(int)    TMR3TimerDestroy(PTMTIMER pTimer);
 VMMR3DECL(int)    TMR3TimerDestroyDevice(PVM pVM, PPDMDEVINS pDevIns);
 VMMR3DECL(int)    TMR3TimerDestroyDriver(PVM pVM, PPDMDRVINS pDrvIns);
Index: /trunk/src/VBox/Devices/Audio/audio.c
===================================================================
--- /trunk/src/VBox/Devices/Audio/audio.c	(revision 19506)
+++ /trunk/src/VBox/Devices/Audio/audio.c	(revision 19507)
@@ -1706,5 +1706,5 @@
     else {
         /* XXX */
-        rc = TMTimerDestroy (s->ts);
+        rc = TMR3TimerDestroy (s->ts);
         return rc;
     }
Index: /trunk/src/VBox/Devices/vl_vbox.h
===================================================================
--- /trunk/src/VBox/Devices/vl_vbox.h	(revision 19506)
+++ /trunk/src/VBox/Devices/vl_vbox.h	(revision 19507)
@@ -90,5 +90,5 @@
 #define qemu_get_clock(enmClock)                TMR3Clock((PVM)cpu_single_env->pVM, enmClock)
 #define qemu_new_timer(clock, callback, user)   (QEMUTimer *)TMR3TimerCreateExternal((PVM)cpu_single_env->pVM, clock, callback, user, __FUNCTION__ )
-#define qemu_free_timer(timer)                  TMTimerDestroy(timer)
+#define qemu_free_timer(timer)                  TMR3TimerDestroy(timer)
 #define qemu_del_timer(timer)                   TMTimerStop(timer)
 #define qemu_mod_timer(timer, expire)           TMTimerSet(timer, (uint64_t)expire)
Index: /trunk/src/VBox/VMM/PDMQueue.cpp
===================================================================
--- /trunk/src/VBox/VMM/PDMQueue.cpp	(revision 19506)
+++ /trunk/src/VBox/VMM/PDMQueue.cpp	(revision 19507)
@@ -127,5 +127,5 @@
             {
                 AssertMsgFailed(("TMTimerSetMillies failed rc=%Rrc\n", rc));
-                int rc2 = TMTimerDestroy(pQueue->pTimer); AssertRC(rc2);
+                int rc2 = TMR3TimerDestroy(pQueue->pTimer); AssertRC(rc2);
             }
         }
@@ -438,5 +438,5 @@
     if (pQueue->pTimer)
     {
-        TMTimerDestroy(pQueue->pTimer);
+        TMR3TimerDestroy(pQueue->pTimer);
         pQueue->pTimer = NULL;
     }
Index: /trunk/src/VBox/VMM/TM.cpp
===================================================================
--- /trunk/src/VBox/VMM/TM.cpp	(revision 19506)
+++ /trunk/src/VBox/VMM/TM.cpp	(revision 19507)
@@ -1352,5 +1352,5 @@
             &&  pDestroy->u.Dev.pDevIns == pDevIns)
         {
-            int rc = TMTimerDestroy(pDestroy);
+            int rc = TMR3TimerDestroy(pDestroy);
             AssertRC(rc);
         }
@@ -1385,5 +1385,5 @@
             &&  pDestroy->u.Drv.pDrvIns == pDrvIns)
         {
-            int rc = TMTimerDestroy(pDestroy);
+            int rc = TMR3TimerDestroy(pDestroy);
             AssertRC(rc);
         }
Index: /trunk/src/VBox/VMM/VMMAll/TMAll.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 19506)
+++ /trunk/src/VBox/VMM/VMMAll/TMAll.cpp	(revision 19507)
@@ -537,4 +537,5 @@
 
 
+#ifdef IN_RING3 /* Kept here until properly cleaned up to not use any of the local functions. */
 /**
  * Destroy a timer
@@ -543,5 +544,5 @@
  * @param   pTimer          Timer handle as returned by one of the create functions.
  */
-VMMDECL(int) TMTimerDestroy(PTMTIMER pTimer)
+VMMR3DECL(int) TMR3TimerDestroy(PTMTIMER pTimer)
 {
     int cRetries = 1000;
@@ -632,4 +633,5 @@
     return VERR_INTERNAL_ERROR;
 }
+#endif /* IN_RING3 */
 
 