Index: trunk/src/VBox/Devices/Serial/DrvRawFile.cpp
===================================================================
--- trunk/src/VBox/Devices/Serial/DrvRawFile.cpp	(revision 19625)
+++ trunk/src/VBox/Devices/Serial/DrvRawFile.cpp	(revision 19626)
@@ -41,6 +41,6 @@
 *******************************************************************************/
 
-/** Converts a pointer to DRVOUTPUTFILE::IMedia to a PDRVOUTPUTFILE. */
-#define PDMISTREAM_2_DRVOUTPUTFILE(pInterface) ( (PDRVOUTPUTFILE)((uintptr_t)pInterface - RT_OFFSETOF(DRVOUTPUTFILE, IStream)) )
+/** Converts a pointer to DRVRAWFILE::IMedia to a PDRVRAWFILE. */
+#define PDMISTREAM_2_DRVRAWFILE(pInterface) ( (PDRVRAWFILE)((uintptr_t)pInterface - RT_OFFSETOF(DRVRAWFILE, IStream)) )
 
 /** Converts a pointer to PDMDRVINS::IBase to a PPDMDRVINS. */
@@ -53,5 +53,5 @@
  * Raw file output driver instance data.
  */
-typedef struct DRVOUTPUTFILE
+typedef struct DRVRAWFILE
 {
     /** The stream interface. */
@@ -63,7 +63,5 @@
     /** Flag whether VirtualBox represents the server or client side. */
     RTFILE              OutputFile;
-    /** Flag to signal listening thread to shut down. */
-    bool                fShutdown;
-} DRVOUTPUTFILE, *PDRVOUTPUTFILE;
+} DRVRAWFILE, *PDRVRAWFILE;
 
 
@@ -74,8 +72,8 @@
 
 /** @copydoc PDMISTREAM::pfnWrite */
-static DECLCALLBACK(int) drvOutputFileWrite(PPDMISTREAM pInterface, const void *pvBuf, size_t *pcbWrite)
+static DECLCALLBACK(int) drvRawFileWrite(PPDMISTREAM pInterface, const void *pvBuf, size_t *pcbWrite)
 {
     int rc = VINF_SUCCESS;
-    PDRVOUTPUTFILE pThis = PDMISTREAM_2_DRVOUTPUTFILE(pInterface);
+    PDRVRAWFILE pThis = PDMISTREAM_2_DRVRAWFILE(pInterface);
     LogFlow(("%s: pvBuf=%p *pcbWrite=%#x (%s)\n", __FUNCTION__, pvBuf, *pcbWrite, pThis->pszLocation));
 
@@ -104,8 +102,8 @@
  * @thread  Any thread.
  */
-static DECLCALLBACK(void *) drvOutputFileQueryInterface(PPDMIBASE pInterface, PDMINTERFACE enmInterface)
+static DECLCALLBACK(void *) drvRawFileQueryInterface(PPDMIBASE pInterface, PDMINTERFACE enmInterface)
 {
     PPDMDRVINS pDrvIns = PDMIBASE_2_DRVINS(pInterface);
-    PDRVOUTPUTFILE pDrv = PDMINS_2_DATA(pDrvIns, PDRVOUTPUTFILE);
+    PDRVRAWFILE pDrv = PDMINS_2_DATA(pDrvIns, PDRVRAWFILE);
     switch (enmInterface)
     {
@@ -130,9 +128,9 @@
  *                      iInstance it's expected to be used a bit in this function.
  */
-static DECLCALLBACK(int) drvOutputFileConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
+static DECLCALLBACK(int) drvRawFileConstruct(PPDMDRVINS pDrvIns, PCFGMNODE pCfgHandle)
 {
     int rc;
     char *pszLocation = NULL;
-    PDRVOUTPUTFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVOUTPUTFILE);
+    PDRVRAWFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVRAWFILE);
 
     /*
@@ -142,9 +140,8 @@
     pThis->pszLocation                  = NULL;
     pThis->OutputFile                   = NIL_RTFILE;
-    pThis->fShutdown                    = false;
     /* IBase */
-    pDrvIns->IBase.pfnQueryInterface    = drvOutputFileQueryInterface;
+    pDrvIns->IBase.pfnQueryInterface    = drvRawFileQueryInterface;
     /* IStream */
-    pThis->IStream.pfnWrite             = drvOutputFileWrite;
+    pThis->IStream.pfnWrite             = drvRawFileWrite;
 
     /*
@@ -180,5 +177,5 @@
     }
 
-    LogFlow(("drvOutputFileConstruct: location %s\n", pszLocation));
+    LogFlow(("drvRawFileConstruct: location %s\n", pszLocation));
     LogRel(("RawFile: location %s\n", pszLocation));
     return VINF_SUCCESS;
@@ -194,7 +191,7 @@
  * @param   pDrvIns     The driver instance data.
  */
-static DECLCALLBACK(void) drvOutputFileDestruct(PPDMDRVINS pDrvIns)
-{
-    PDRVOUTPUTFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVOUTPUTFILE);
+static DECLCALLBACK(void) drvRawFileDestruct(PPDMDRVINS pDrvIns)
+{
+    PDRVRAWFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVRAWFILE);
     LogFlow(("%s: %s\n", __FUNCTION__, pThis->pszLocation));
 
@@ -211,10 +208,8 @@
  * @param   pDrvIns     The driver instance data.
  */
-static DECLCALLBACK(void) drvOutputFilePowerOff(PPDMDRVINS pDrvIns)
-{
-    PDRVOUTPUTFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVOUTPUTFILE);
+static DECLCALLBACK(void) drvRawFilePowerOff(PPDMDRVINS pDrvIns)
+{
+    PDRVRAWFILE pThis = PDMINS_2_DATA(pDrvIns, PDRVRAWFILE);
     LogFlow(("%s: %s\n", __FUNCTION__, pThis->pszLocation));
-
-    pThis->fShutdown = true;
 
     if (pThis->OutputFile != NIL_RTFILE)
@@ -241,9 +236,9 @@
     ~0,
     /* cbInstance */
-    sizeof(DRVOUTPUTFILE),
+    sizeof(DRVRAWFILE),
     /* pfnConstruct */
-    drvOutputFileConstruct,
+    drvRawFileConstruct,
     /* pfnDestruct */
-    drvOutputFileDestruct,
+    drvRawFileDestruct,
     /* pfnIOCtl */
     NULL,
@@ -259,4 +254,4 @@
     NULL,
     /* pfnPowerOff */
-    drvOutputFilePowerOff,
+    drvRawFilePowerOff,
 };